#ifndef UHOST
#define UHOST
/*e.****************************************************
*        Constants for the uHost card                  *
********************************************************/
/*r.****************************************************
*        Константы для платы uHost                     *
********************************************************/
/*e.  file for the C code                              */
/*r.  файл для кода на С                               */

#define FIRMWARE_VER	 0x00			 //e. firmware version number //r. номер версии микропрограммы

	        //e. ====================== registers of the system controller of the DSP card ================ //r. ====================== регистры системного контроллера платы DSP ================
#define  Sys_RgE         0x07fb          //e. the line1_err register of line errors  //r. регистр ошибок линии line1_err  
#define  Sys_RgR         0x07fc          //e. the register of a mode of the system (only write) //r. регистр режима системы (только запись)  
#define  Sys_RgS         0x07fc          //e. the register of a status of the system (only read) //r. регистр статуса системы (только чтение)  
#define  Trm_data        0x07fd          //e. the data stack of the transmitter //r. стек данных передатчика  
#define  Rcv_data        0x07fd          //e. the data stack of the receiver //r. стек данных приемника  
#define  Rcv_cntr        0x07fe          //e. the counter of the received bytes //r. счетчик принятых байт приемника  

        //e. ====================== bits of the Sys_RgS status register ========================= //r. ====================== биты регистра состояния Sys_RgS =========================
#define  RCV_RDY_MASK    0x0040          //e. a mask of the readiness bit of the receiver //r. маска бита готовности приемника  
#define  RCV_FERR_MASK   0x0020          //e. a mask of the "format error" bit //r. маска бита "ошибка формата" 
#define  RCV_TOUT_MASK   0x0010          //e. a mask of the "time-out" bit //r. маска бита "тайм-аут" 
#define  RCV_RFUL_MASK   0x0008          //e. a mask of the "stack is full" bit//r. маска бита "стек полон"  
#define  RCV_FERR        0x0020          //e. a mask of the "format error" bit //r. маска бита "ошибка формата" 
#define  RCV_TOUT        0x0010          //e. a mask of the "time-out" bit //r. маска бита "тайм-аут" 
#define  RCV_RFUL        0x0008          //e. a mask of the "stack is full" bit//r. маска бита "стек полон"  

#define INT_ERR_TC		0x00000008 

#define FromFLASH		0x00003
#define ByDefault		0x00001




#define  SetV1 LPC_GPIO1->FIOSET=(1<<25);
#define  ClrV1 LPC_GPIO1->FIOCLR = (1<<25);
#define  SetV2 LPC_GPIO1->FIOSET = (1<<28);
#define  ClrV2 LPC_GPIO1->FIOCLR = (1<<28);
#define  LoopOn  LPC_GPIO1->FIOSET  = (1<<30);	
#define  LoopOff LPC_GPIO1->FIOCLR  = (1<<30);	
#define  StartV1  0	
#define  StartV2 15		
#define  TIME_INTERVAL	(7812)



extern uint32_t	blt_in_test;

void LoadFlashParam(unsigned );	
void FlashDMA_Init(void);
void init_DefaultParam(void);
#endif

